// Blur
// Paulo Ricardo Reinehr
// PS 2.0
// Simple blur with blending control.


//#PARAM percent blending 1 : Blending : Blur blending with the original image.
float blending;


// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};


float pixelWidth;
float pixelHeight;


// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{

	float4 blur = tex2D( foreground , Tex.xy );
	blur += tex2D( foreground , Tex.xy + float2( -pixelWidth , -pixelHeight )) * 0.6 ;
	blur += tex2D( foreground , Tex.xy + float2( 0 , -pixelHeight ));
	blur += tex2D( foreground , Tex.xy + float2( pixelWidth , -pixelHeight )) * 0.6 ;
	blur += tex2D( foreground , Tex.xy + float2( -pixelWidth , 0 ));
	blur += tex2D( foreground , Tex.xy + float2( pixelWidth , 0 ));
	blur += tex2D( foreground , Tex.xy + float2( -pixelWidth , pixelHeight )) * 0.6 ;
	blur += tex2D( foreground , Tex.xy + float2( 0 , pixelHeight ));
	blur += tex2D( foreground , Tex.xy + float2( pixelWidth , pixelHeight )) * 0.6 ;

	blur /= 7.4 ;

	blur = blur * blending + (1.0 - blending) * tex2D( foreground , Tex.xy );

	return blur;

}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}