// Coloured Outline
// Original Outline by Ashley Gullen
// PS 2.0
// Draw a coloured line around the image.

//#CROSS-SAMPLING : reads pixels it may be writing.
//#BORDER-MODE : samples pixels outside bounding box
//#PARAM float thickness 5 : Thickness : Thickness of the outline.
//#PARAM percent Red 1: Red : Red colour component
//#PARAM percent Green 0.5: Green : Green colour component
//#PARAM percent Blue 1: Blue : Blue colour component
//#PARAM percent Alpha 1: Alpha : Colour alpha
float thickness;
float Red;
float Green;
float Blue;
float Alpha;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

float pixelWidth;
float pixelHeight;

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float4 here = tex2D(foreground, Tex.xy);
    float4 left = tex2D(foreground, float2(Tex.x - pixelWidth * thickness, Tex.y));
    float4 right = tex2D(foreground, float2(Tex.x + pixelWidth * thickness, Tex.y));
    float4 top = tex2D(foreground, float2(Tex.x, Tex.y - pixelHeight * thickness));
    float4 bottom = tex2D(foreground, float2(Tex.x, Tex.y + pixelHeight * thickness));


    if (here.a == 0) {
        if (left.a != 0 || right.a != 0 || top.a != 0 || bottom.a != 0) {
            //return float4(1,1,1,1);
            return float4(Red * Alpha, Green * Alpha, Blue * Alpha, Alpha);
        }
	else return float4(0,0,0,0);
    }
    else return here;

}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
