// ZoomBlur
// tULAMIDE
// PS 2.0
// A zoomed blur.

//#PARAM percent blurAmount 0.125 : Blur : Amount of blur to be applied.
//#PARAM percent centerX 0.5 : Horizontal Center : The horizontal position of the center.
//#PARAM percent centerY 0.5 : Vertical Center : The vertical position of the center.

float blurAmount;
float centerX;
float centerY;

float boxWidth;
float boxHeight;
float hotspotX;
float hotspotY;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float2 center = float2(hotspotX + (centerX - 0.5) * boxWidth, hotspotY + (centerY - 0.5) * boxHeight);
    float amount = blurAmount * -1.0;
    float4 color = 0;
    Tex -= center;
    for(int i=0; i<15; i++)
    {
        float scale = 1.0 + amount * (i / 14.0);
        color += tex2D(foreground, Tex * scale + center);
    }

    color /= 15;
    return color;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}